﻿//Register for MDS enabled site otherwise the display template doesn't work on refresh
RegisterModuleInit("/_catalogs/masterpage/Display%20Templates/csr_ovr_Blockbusters.js", RegisterBlockbustersOverride); // CSR-override for MDS enabled site
RegisterBlockbustersOverride(); //CSR-override for MDS disabled site (because we need to call the entry point function in this case whereas it is not needed for anonymous functions)
  


function RegisterBlockbustersOverride () {
    /*
     * Initialize the variable that store the overrides objects.
     */
	var overrideCtx = {};
	overrideCtx.Templates = {};
	
	blockbusterItemWidth = 5;
	blockbusterItemRow = 0;
	blockbusterOffsetVertical = 0; //Usually 25

	
//	Assign functions or plain html strings to the templateset objects:
//	header, footer and item.
	var registerCssTag = "<link href='/_catalogs/masterpage/Display%20Templates/blockbusters.css' rel='stylesheet' type='text/css'/>";
	var blockbusterWhiteTop = "<ul class='blockbusters'><li class='blockbusterBlue'></li><li class='blockbusterWhite blockbustersWrapperOdd'></li><li class='blockbusterWhite'></li>" +
		"<li class='blockbusterWhite blockbustersWrapperOdd'></li><li class='blockbusterWhite'></li><li class='blockbusterWhite blockbustersWrapperOdd'></li><li class='blockbusterBlue'></li></ul>"
		
	var blockbusterWhiteBottom = "<ul class='blockbusters' style='top:-12px;'><li class='blockbusterSpacer'></li><li class='blockbusterWhite blockbustersWrapperOdd'></li><li class='blockbusterWhite'></li>" +
		"<li class='blockbusterWhite blockbustersWrapperOdd'></li><li class='blockbusterWhite'></li><li class='blockbusterWhite blockbustersWrapperOdd'></li><li class='blockbusterSpacer'></li></ul>"
		
	overrideCtx.Templates.Header = registerCssTag + blockbusterWhiteTop;
	overrideCtx.Templates.Footer = "</ul>" + blockbusterWhiteBottom;

// 	This template is assigned to the CustomItem function.
	overrideCtx.Templates.Item = CustomItem;
	overrideCtx.BaseViewID = 1;
	overrideCtx.ListTemplateType = 100;

//   	 Register the template overrides.

	SPClientTemplates.TemplateManager.RegisterTemplateOverrides(overrideCtx);

};

/*
 * This function builds the output for the item template.
 * Uses the Context object to access announcement data.
 */
function CustomItem(ctx) {
    // Build a listitem entry for every entry in the list.
   	var currItem = ctx.CurrentItem
    var ret = "";
   
    if (ctx.CurrentItemIdx % blockbusterItemWidth == 0)
	{	
		if (blockbusterItemRow == 0)
		{
			//ret += "<ul class='blockbusters blockbustersOdd'><li class='blockbusterBlue'>&nbsp;</li>"
			ret += "<ul class='blockbusters'><li class='blockbusterBlue'>&nbsp;</li>"
			modOperator = 0;
		}
		else
		{
			ret += "<li class='blockbusterBlue'>&nbsp;</li></ul><ul class='blockbusters' ><li class='blockbusterBlue'>&nbsp;</li>"
		}
	
		blockbusterItemRow+= 1;
	}

   	var hoverPanelId = "blockbusterQuestionHoverPanelID" + ctx.CurrentItemIdx;
   	var answerPanelId = "blockbusterAnswerHoverPanelID" + ctx.CurrentItemIdx;
   	var listItemId = "blockbustersItem" + ctx.CurrentItemIdx;
   	var liClass = ""
   	
   	if (ctx.CurrentItemIdx % 2 == 0)
   	{
   		if (blockbusterItemRow % 2 == 0)
   		{
   			liClass = "blockbustersWrapper";
   		}
   		else
   		{
   			liClass = "blockbustersWrapper blockbustersWrapperOdd";
   		}
   	}
   	else
   	{
   		if (blockbusterItemRow % 2 != 0)
   		{
   			liClass = "blockbustersWrapper";
   		}
   		else
   		{
   			liClass = "blockbustersWrapper blockbustersWrapperOdd";
   		}
   	}
   	
    ret += "<li id='" + listItemId + "' class='" + liClass + "'>" +
     "<div class='blockbusterLetter' OnClick=blockbusterQuestionToggle('" +  hoverPanelId + "') " +
     "OnMouseOut=blockbusterQuestionHide('" +  hoverPanelId + "')>";
	ret += currItem.Title + "</div>";
	ret += "<div class='blockbusterAnswerIcon' OnClick=blockbusterQuestionToggle('" + answerPanelId + "') OnMouseOut=blockbusterQuestionHide('" +
		answerPanelId + "')>@</div>";
   	ret += "<div class='blockbusterQuestionHover' id='" + hoverPanelId + "'>" + ctx.CurrentItem.Question + "</div>" +
   	"<div class='blockbusterAnswerHover' id='" + answerPanelId + "'>" + ctx.CurrentItem.Answer + "</div>";
   	ret += "<div class='blockbusterW' OnClick=blockbusterReplaceSquare('" + listItemId + "','White')>W</div><div class='blockbusterB' OnClick=blockbusterReplaceSquare('" + listItemId + "','Blue')>B</div></li>";
   	
   	if (ctx.CurrentItemIdx == 19)
   	{
   		ret += "<li class='blockbusterBlue' style='margin-left:-18px;'>&nbsp;</li>"
   	}
	return ret;
}

function blockbusterQuestionToggle(hoverPanelID)
{
	$('#' + hoverPanelID).toggle();
}

function blockbusterQuestionHide(hoverPanelID)
{
	$('#' + hoverPanelID).hide();
}

function blockbusterReplaceSquare(itemId,colour)
{
	//need to check for whether odd tag is used.
	var currentTag = $('#' + itemId);
	if (currentTag.hasClass('blockbustersWrapperOdd'))
	{
			currentTag.replaceWith("<li id='" + itemId + "' class='blockbuster" + colour + " blockbustersWrapperOdd'>&nbsp;</li>");
	}
	else
	{
		currentTag.replaceWith("<li id='" + itemId + "' class='blockbuster" + colour + "'>&nbsp;</li>");
	}
}
