﻿//Register for MDS enabled site otherwise the display template doesn't work on refresh
RegisterModuleInit("/_catalogs/masterpage/Display%20Templates/csr_ovr_SimpleList.js", RegisterCountdownOverride); // CSR-override for MDS enabled site
RegisterCountdownOverride(); //CSR-override for MDS disabled site (because we need to call the entry point function in this case whereas it is not needed for anonymous functions)


/* Set-up globals */
	var consonantList = new Array();
	var vowelList = new Array();
	var clickTracker = 0;
	var countupSeconds = 0;
	var intervalTimer;
  
function RegisterCountdownOverride () {
    /*
     * Initialize the variable that store the overrides objects.
     */
	var overrideCtx = {};
	overrideCtx.Templates = {};
	
//	Assign functions or plain html strings to the templateset objects:
//	header, footer and item.

	overrideCtx.Templates.Header = SetUpHeader
	overrideCtx.Templates.Footer = SetUpFooter

// 	This template is assigned to the CustomItem function.
	overrideCtx.Templates.Item = CustomItem;
	overrideCtx.BaseViewID = 1;
	overrideCtx.ListTemplateType = 100;
	
//  Register the template overrides with SharePoint
	SPClientTemplates.TemplateManager.RegisterTemplateOverrides(overrideCtx);
};

function SetUpHeader()
{
	var registerCssTag = "<link href='/_catalogs/masterpage/Display%20Templates/countdown.css' rel='stylesheet' type='text/css'/>";
	var headerHtml = registerCssTag;
	return headerHtml;
}

/*
 * This function builds the output for the item template.
 * Uses the Context object to access list item data.
 */
function CustomItem(ctx) {
    // Build a listitem entry for every entry in the list.
    if (ctx.CurrentItem.LetterType == "Consonant")
    {
    	consonantList.push(ctx.CurrentItem.Title);
    }
    else
    {
    	vowelList.push(ctx.CurrentItem.Title);
    }   
    var returnHtml = ""
	return returnHtml;
}

function SetUpFooter()
{
	var footerHtml = BuildCountdownControls();
	footerHtml += BuildGameBoard();
	return footerHtml;
}

function BuildCountdownControls()
{
	var countdownControls = "<div class='countdownControls'>"	
	countdownControls += "<ul><li onclick=processClick('Consonant')>Consonant</li>"
	countdownControls += "<li onclick=processClick('Vowel')>Vowel</li></ul>"
	countdownControls += "</div>";
	countdownControls += "<audio id='countdownPlayer' preload='auto' style='display:none;'><source src='/_catalogs/masterpage/display templates/countdown-clock.mp3' type='audio/mpeg'>Your browser does not support this audio format.</audio> ";
	countdownControls += "<div id='clockWrapper'><ul id='clock'><li id='sec'></li><li id='hour'></li><li id='min'></li></ul></div>";
	return countdownControls;
}

function BuildGameBoard()
{
	var gameBoard = "<div class='gameBoard'><ul>";
	for (var i=0; i<9; i++)
	{
		gameBoard += "<li id='gameBoardCell" + i + "'>&nbsp;</li>";
	}
	gameBoard += "</ul></div>";
	return gameBoard;
}

function processClick(selectedLetterType)
{
	if (clickTracker == 9)
	{
		alert("Too many");
		return;
	}
	var selectedLetter = "";
	
	if (selectedLetterType == "Consonant")
	{
		var index = Math.floor(Math.random()* (consonantList.length -1));
		selectedLetter = consonantList[index];
	}
	else
	{
		var index = Math.floor(Math.random()* (vowelList.length -1));
		selectedLetter = vowelList[index];
	}
	
	$('#gameBoardCell' + clickTracker).html(selectedLetter);
	clickTracker++;
	
	if (clickTracker == 9)
	{
		setupClock();
		document.getElementById('countdownPlayer').play();
	}
}

function setupClock() {
 
	$('#clockWrapper').show();
	intervalTimer = setInterval( function() {
	
	if (countupSeconds == 29)
	{
		clearInterval(intervalTimer);
		$('#clockWrapper').hide();
		$('.gameBoard UL LI').css('background-color','red');
	}
	countupSeconds++;
	var seconds = countupSeconds;
	var sdegree = seconds * 6;
	var srotate = "rotate(" + sdegree + "deg)";
	
	$("#sec").css({ "transform": srotate });
	  
	}, 1000 );
}
