﻿//Register for MDS enabled site otherwise the display template doesn't work on refresh
RegisterModuleInit("/_catalogs/masterpage/Display%20Templates/csr_ovr_PercentComplete_Field.js", RegisterSimpleFieldOverride); // CSR-override for MDS enabled site
RegisterSimpleFieldOverride(); //CSR-override for MDS disabled site (because we need to call the entry point function in this case whereas it is not needed for anonymous functions)

/* If we override a tasklist, we actually break the SharePoint rendering.
 * To avoid this, we need to include a call to the standard SharePoint Task list rendering script
 */
RegisterSod('hierarchytaskslist.js', '/_layouts/15/hierarchytaskslist.js');
LoadSodByKey('hierarchytaskslist.js', null);


  
function RegisterSimpleFieldOverride() {

	//   Initialize the variables for overrides objects
	var overrideCtx = {};
	overrideCtx.Templates = {};

	//  Use BaseViewID and ListTemplateType to narrow focus/scope on 
	//	which web parts on the page are affected
	overrideCtx.BaseViewID = 1; //We're only using the Base view ID on this one.
	//overrideCtx.ListTemplateType = 107;

    /*
     * Using the Fields override leaves the rest of the rendering intact, but 
     * allows control over one or more specific fields in the existing view
     */
	overrideCtx.Templates.Fields = {
		'PercentComplete': {'View' : CustomPercentCompleteField }
	};
		
    /*
     * Register the template overrides.
     */
	SPClientTemplates.TemplateManager.RegisterTemplateOverrides(overrideCtx);
};

/*
 * This function builds the output for the item template.
 * Uses the Context object to access list item data.
 */
function CustomPercentCompleteField(ctx) {
    // Build a listitem entry for every entry in the list.
    var returnHtml = "<div style='background:#bcbcbc; display:block; height:20px; width:100px;position:relative;'>";
    returnHtml += "<span style='color:#000000; position:absolute; left:5px;'>" + ctx.CurrentItem.PercentComplete + "</span>";
    returnHtml += "<div style='background-color:red; height:100%; width:" + ctx.CurrentItem.PercentComplete.replace(" %","") + "'>";
    returnHtml += "</div></div>";
	return returnHtml;
}

